--[[
	Based on an idea from sarf (Free Bag Slots)

	Originally coded by Hamunaptra.
	Currently updated by Earl_Parvisjam

	This mod displays free and total slots in all bags.
	Added bag slots info for bank bags, and additional updates as requested.
   ]]
 
--Debugging Code
SLASH_RELOADUI1 = "/rl" -- faster reload
SlashCmdList["RELOADUI"] = ReloadUI

local addonName, NS = ...

--local tmp = getglobal("BM_Option_Total");
--Bagmeter_Print(tmp:GetName());

function Bagmeter_OnLoad(self)
	self:RegisterEvent("BAG_UPDATE");
	self:RegisterEvent("UNIT_INVENTORY_CHANGED");
	self:RegisterEvent("BANKFRAME_OPENED");
	SLASH_BAGMETER1 = "/bagm";
    SlashCmdList["BAGMETER"] = Bagmeter_CommandHandler;
	local version = GetAddOnMetadata("Bagmeter", "Version")
	Bagmeter_Print("Bagmeter "..version.." loaded.", "yellow");
end

function Bagmeter_CommandHandler(msg)
	local Cmd, Arg = Bagmeter_ParseMsg(msg);
 	if (Cmd == "total") then
 		Bagmeter_Total = Arg;
		Bagmeter_OnEvent(1);
 	elseif (Cmd == "subtotal") then
 		Bagmeter_Subtotal = Arg;
 		Bagmeter_OnEvent(1);
	elseif (Cmd == "subcount") then
	 	Bagmeter_Subcount = Arg;
 		Bagmeter_OnEvent(1);
 	elseif (Cmd == "color") then
 		Bagmeter_Color = Arg;
 		Bagmeter_OnEvent(1);
 	elseif (Cmd == "show") then
 		Bagmeter_Used = Arg;
 		Bagmeter_OnEvent(1);
 	elseif (Cmd == "status") then
 		Bagmeter_DisplayStatus();
 	else
 		Bagmeter_DisplayHelp();
 	end;
end;

function Bagmeter_OnEvent(event)
	local i, j, ofree, ototal, cfree, ctotal, obj, txt1, txt2, col, ratio;
	ofree = 0;
	ototal = 0;
	for i = 0, 4 do
		cfree = C_Container.GetContainerNumFreeSlots(i)
		ctotal = C_Container.GetContainerNumSlots(i);
		ofree = ofree + cfree;
		ototal = ototal + ctotal;
		obj = getglobal("BM_Bag"..i.."Txt");

		if (Bagmeter_Used == 1) then
			txt2 = ctotal - cfree;
		else
			txt2 = cfree;
		end

		if (Bagmeter_Subcount == 1) then
			if (Bagmeter_Subtotal == 1) then
				txt1 = txt2.."/"..ctotal;
			else
				txt1 = txt2;
			end
		else
			if (Bagmeter_Subtotal == 1) then
				txt1 = ctotal;
			else
				txt1 = "";
			end
		end
		
		col = "white";
		
		if (i > 0) then
			local bag = getglobal("CharacterBag"..(i-1).."Slot");
			local point, relativeTo, relativePoint, xofs, yofs = bag:GetPoint();
			bag:SetPoint(point, relativeTo, relativePoint, -1*Bagmeter_Offset, 0);
		end
		if (Bagmeter_Color == 1) then
			ratio = cfree / ctotal;
			col = "green";
			if (ratio < 0.66) then col = "yellow"; end
			if (ratio < 0.33) then col = "red"; end
		end
		Bagmeter_SetAlign(obj);
		Bagmeter_SetSize(obj, Bagmeter_FontSize);
		obj:SetText(txt1);
		obj:SetTextColor(Bagmeter_GetColor(col));
		obj:Show();
		obj = getglobal("BM_Bag"..i.."Frame");
        if ( ctotal > 0) then
            obj:Show();
		else
		    obj:Hide();
		end
	end

	--Reagent Bag

	cfree = C_Container.GetContainerNumFreeSlots(5)
	ctotal = C_Container.GetContainerNumSlots(5);
	ofree = ofree + cfree;
	ototal = ototal + ctotal;
	obj = getglobal("BM_ReagentBag0Txt");

	if (Bagmeter_Used == 1) then
		txt2 = ctotal - cfree;
	else
		txt2 = cfree;
	end

	if (Bagmeter_Subcount == 1) then
		if (Bagmeter_Subtotal == 1) then
			txt1 = txt2.."/"..ctotal;
		else
			txt1 = txt2;
		end
	else
		if (Bagmeter_Subtotal == 1) then
			txt1 = ctotal;
		else
			txt1 = "";
		end
	end
		
	col = "white";
		
	local bag = getglobal("CharacterReagentBag0Slot");
	local point, relativeTo, relativePoint, xofs, yofs = bag:GetPoint();
	bag:SetPoint(point, relativeTo, relativePoint, -1*Bagmeter_Offset, 0);

	if (Bagmeter_Color == 1) then
		ratio = cfree / ctotal;
		col = "green";
		if (ratio < 0.66) then col = "yellow"; end
		if (ratio < 0.33) then col = "red"; end
	end
	Bagmeter_SetAlign(obj);
	Bagmeter_SetSize(obj, Bagmeter_FontSize);
	obj:SetText(txt1);
	obj:SetTextColor(Bagmeter_GetColor(col));
	obj:Show();
	obj = getglobal("BM_ReagentBag0Frame");
       if ( ctotal > 0) then
           obj:Show();
	else
	    obj:Hide();
	end

	--Bank Bags

	for i = 6, (4 + GetNumBankSlots()) do
		cfree = C_Container.GetContainerNumFreeSlots(i)
		ctotal = C_Container.GetContainerNumSlots(i);
		ofree = ofree + cfree;
		obj = getglobal("BM_Bag"..i.."Txt");
		if (Bagmeter_Used == 1) then
			txt2 = ctotal - cfree;
		else
			txt2 = cfree;
		end

		if (Bagmeter_Subcount == 1) then
			if (Bagmeter_Subtotal == 1) then
				txt1 = txt2.."/"..ctotal;
			else
				txt1 = txt2;
			end
		else
			if (Bagmeter_Subtotal == 1) then
				txt1 = ctotal;
			else
				txt1 = "";
			end
		end
		
		col = "white";
		
		if (Bagmeter_Color == 1) then
			ratio = cfree / ctotal;
			col = "green";
			if (ratio < 0.66) then col = "yellow"; end
			if (ratio < 0.33) then col = "red"; end
		end

		obj:SetText(txt1);
		obj:SetTextColor(Bagmeter_GetColor(col));

		obj = getglobal("BM_Bag"..i.."Frame");
        if ( ctotal > 0) then
            obj:Show();
		else
		    obj:Hide();
		end
	end

	if (Bagmeter_Used == 1) then
		txt1 = ototal - ofree;
	else
		txt1 = ofree;
	end
	
	if (Bagmeter_Total == 1) then
		BM_BagXTxt:SetText(txt1.."/"..ototal);
	else
		BM_BagXTxt:SetText("");
	end
	
	col = "white";
		
	if (Bagmeter_Color == 1) then
		ratio = ofree / ototal;
		col = "green";
		if (ratio < 0.66) then col = "yellow"; end
		if (ratio < 0.33) then col = "red"; end
	end

	BM_BagXTxt:SetTextColor(Bagmeter_GetColor(col));
end

---------------------------------------------------
-- Command Prompt Functionality
---------------------------------------------------

function Bagmeter_DisplayHelp()
	Bagmeter_Print("---------------------------------------", "yellow");
	Bagmeter_Print("Bagmeter usage:", "yellow");
	Bagmeter_Print("/bagm total on/off -> Show or hide free/used space overall", "white");
	Bagmeter_Print("/bagm subcount on/off -> Show or hide per bag counts", "white");
	Bagmeter_Print("/bagm subtotal on/off -> Show or hide free/used space per bag", "white");
	Bagmeter_Print("/bagm color on/off -> Use colors for the bag utilization", "white");
	Bagmeter_Print("/bagm show free/used -> Show either the free or the used spaces per bag and overall", "white");
	Bagmeter_Print("/bagm status -> Show the current status of the settings", "white");
	Bagmeter_Print("---------------------------------------", "yellow");
end

function Bagmeter_DisplayStatus()
	Bagmeter_Print("---------------------------------------", "yellow");
	Bagmeter_Print("Current bagmeter settings:", "yellow");
	Bagmeter_Print("Show total: "..Bagmeter_ParseSet(Bagmeter_Total), "white");
	Bagmeter_Print("Show subtotals: "..Bagmeter_ParseSet(Bagmeter_Subtotal), "white");
	Bagmeter_Print("Show subcounts: "..Bagmeter_ParseSet(Bagmeter_Subcount), "white");
	Bagmeter_Print("Use colors: "..Bagmeter_ParseSet(Bagmeter_Color), "white");
	Bagmeter_Print("Show used count: "..Bagmeter_ParseSet(Bagmeter_Used), "white");
	Bagmeter_Print("Font Size: "..Bagmeter_FontSize, "white");
	Bagmeter_Print("---------------------------------------", "yellow");
end



