local addonName, Namespace = ...

function Bagmeter_GetColor(color)
	if (color == "green") then return 0, 1, 0; end
	if (color == "red") then return 1, 0, 0; end
	if (color == "yellow") then	return 1, 1, 0;	end
	return 1, 1, 1;
end

function Bagmeter_Print(msg, color)
	local r, g, b;
	if (msg == nil) then return; end
	r, g, b = Bagmeter_GetColor(color);
	if( DEFAULT_CHAT_FRAME ) then DEFAULT_CHAT_FRAME:AddMessage(msg, r, g, b); end
end

function Bagmeter_ParseMsg(msg)
    if msg then
        local txt
        local a, b, c = strfind(msg, "(%S+)");
        if a then
            txt = strsub(msg, b + 2);
            if (txt == "on" or txt == "used" or txt == "yes" or txt == "1") then
                return c, 1;
            else
                return c, 0;
            end
        else
            return "";
        end
    end
end

function Bagmeter_ParseSet(setting)
	if (setting == 1) then return "yes"; end
	return "no";
end	

function Bagmeter_SetSize(bag, size)
	local a, b, c;
	a, b, c = bag:GetFont();
	bag:SetFont(a, size, c);
end

function Bagmeter_SetAlign(text)
    local bag = text:GetParent();
    text:SetJustifyH(Bagmeter_Horizontal);
    text:ClearAllPoints();
    if Bagmeter_Vertical == "TOP" then
        text:SetPoint("TOPLEFT", 0, 0);
    elseif Bagmeter_Vertical == "MIDDLE" then
        local offset = (bag:GetHeight()/(-2)) + (Bagmeter_FontSize/2)
        text:SetPoint("TOPLEFT", 0, offset)
    else
        text:SetPoint("TOPLEFT", 0, -bag:GetHeight()+ (Bagmeter_FontSize/2))
    end
end


--RESIZE CODE
--local offset = (backpack:GetHeight()-8)/(-2)
--text:SetPoint("TOPLEFT", 0, offset + 2)
--Bagmeter_Print("backpack: "..backpack:GetHeight())
